#include "corpinc.h"

#define FROBFILE "corpfrob.c"

void frobheader(FILE*);      
void enclitics(FILE*,FILE*);
void muls(FILE*,FILE*);
void bigfrobs(FILE*,FILE*);
void stripnl(char*);

void MakeFrob()     
{
	FILE *frob, *fenc, *fmul, *fbig;
	frob=fopen(FROBFILE,"w");
	if (frob==NULL) return;
	frobheader(frob);
	fenc=fopen("enclitic.frb","r");	
	enclitics(fenc,frob);               
	fclose(fenc);
	fmul=fopen("multiple.frb","r");	
	muls(fmul,frob);                    
	fclose(fmul);
	fbig=fopen("single.frb","r");
	bigfrobs(fbig,frob);
	fclose(fbig);
	fclose(frob);
}         

int nenclitics;

char enclit1[MAXENC][MAXWORD];       

void frobheader(FILE* out)
{
	fprintf(out,"#include \"corpinc.h\"\n\n");
}	

void enclitics(FILE* in,FILE* out)
{
	int i=0; int j;
	while (fscanf(in,"%s ",enclit1[i]) != EOF) i++;
	fprintf(out,"int nenclitic=%d;\n",i);
	fprintf(out,"char* enclit[MAXENC]={\n");
	for (j=0;j<i-1;j++)	                   
		fprintf(out,"\t\"%s\",\n",enclit1[j]);
	fprintf(out,"\t\"%s\"};\n\n",enclit1[i-1]);
}		                     

int nmul;

char mul1[MAXMUL][MAXWORD];
char demul1[MAXMUL][MAXWORD];          

void muls(FILE* in,FILE* out)
{                            
	int i=0; int j, jj;
	char m[MAXWORD];
	while (fscanf(in,"%s ",m) != EOF) {
		stripnl(m);
		j=0; jj=0;
		while (m[j]) {    
			if (m[j] != '/') mul1[i][jj++]=m[j];
			demul1[i][j]=(m[j]=='/')?' ':m[j];
			j++;
		}                    
		i++;
	}
	fprintf(out,"int nmul=%d;\n",i);		
	fprintf(out,"char* mul[MAXMUL]={\n");
	for (j=0;j<i-1;j++)
		fprintf(out,"\t\"%s\",\n",mul1[j]);
	fprintf(out,"\t\"%s\"};\n",mul1[i-1]);
	fprintf(out,"char* demul[MAXMUL]={\n");
	for (j=0;j<i-1;j++)
		fprintf(out,"\t\"%s\",\n",demul1[j]);
	fprintf(out,"\t\"%s\"};\n",demul1[i-1]);
}                  

struct _ft fptab[MAXFROBPOS];	


int nfrobpos;
int nfrobs;
char frobs1[MAXFROBS][MAXWORD];


void bigfrobs(FILE* in,FILE* out)				
{
	char m[MAXWORD];
	int iff=0; int ift=0; int j;
	while (fgets(m,MAXWORD,in)) {
		BOOL b1; int k;                      
		char* s;
		stripnl(m);
		k=0;
		s=strtok(m,", \n\r");
		if (!s) continue;    
		b1=TRUE;
		do {
			strcat(frobs1[iff],s);
			strcpy(fptab[ift].word,s);
			fptab[ift].frob=iff;
			fptab[ift].offset=k;
			fptab[ift].b1=b1;
			k+=strlen(s);
			b1=FALSE;
			s=strtok(NULL,", \n\r");
			fptab[ift].b2=(s==NULL);
			ift++;
			if (s) {
				strcat(frobs1[iff]," ");
				k++;
			}
		} while (s);
		iff++;
	}			  
	fprintf(out,"int nfrobs=%d;\n",iff);
	fprintf(out,"char* frobs[MAXFROBS]={\n");
	for (j=0;j<iff-1;j++)
		fprintf(out,"\t\"%s\",\n",frobs1[j]);
	fprintf(out,"\t\"%s\"};\n",frobs1[iff-1]);
	fprintf(out,"int nfrobpos=%d;\n",ift);
	fprintf(out,"struct _ft fptab[MAXFROBPOS]={\n");
	for (j=0;j<ift-1;j++)
		fprintf(out,"\t{\"%s\",%d,%d,%d,%d},\n",fptab[j].word,
			fptab[j].frob,fptab[j].offset,fptab[j].b1,fptab[j].b2);
	fprintf(out,"\t{\"%s\",%d,%d,%d,%d}};\n\n",fptab[ift-1].word,
		fptab[ift-1].frob,fptab[ift-1].offset,fptab[ift-1].b1,fptab[ift-1].b2);
}		

void stripnl(char* m)
{
	if (m[strlen(m)-1]=='\n') m[strlen(m)-1]=0;
}
	


	
	

	